package census;

import ij.*;
import ij.measure.Measurements;
import ij.plugin.frame.PlugInFrame;
import ij.io.*;
import ij.process.*;
import ij.gui.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.lang.*;

/**
 * CensusObject
 *
 * COPY IN
 *
 * @author Peter Sebastian Masny
 * @version 1.0 26 January 2005
 */

public class RoiBreed extends CensusObject {
    
    public boolean find(int x, int y, ImagePlus img, int color) {
        super.find(x,y,img,color);
        roi = img.getRoi();
        ImageStatistics is = img.getStatistics(ij.measure.Measurements.CENTROID);
        this.x = (int)is.xCentroid;
        this.y = (int)is.yCentroid;
        if (roi == null) roi = new OvalRoi(x-7,y-7,15,15);
        return true;
    }
    
    public boolean loadFromString(String s, ImagePlus img) {
        boolean located = super.loadFromString(s, img);
        String[] values = s.split(IO_DELIMITER, -1);
        String roiFile = values[values.length-1];
        IJ.write(roiFile);
        if (located) {
           try {
              roi = (new RoiDecoder(img.getOriginalFileInfo().directory.replace('\\','/')+roiFile)).getRoi();
           } catch (IOException e) {
               IJ.showMessage("ERROR loading roi. FileIO Error: ", ""+e);
               return false;
           }
        }
        return located;
    }
    
    public String asString() {
        String output = super.asString();
        String roiFile = img.getOriginalFileInfo().fileName+"--"+new Date().getTime()+".roi";
        RoiEncoder re = new RoiEncoder(img.getOriginalFileInfo().directory.replace('\\','/')+roiFile);
        try {
            re.write(roi);
        } catch (IOException e) {
            IJ.showMessage("ERROR saving roi. FileIO Error: ", ""+e);
            return null;
        }
        output += IO_DELIMITER + roiFile ;
        return output;
    }
    
}